; Modul klavesnice
;
; * Konstanty
;   * Pouzity register R25			- Vlajky stlacenych tlacidiel
;	* Pouzity register R24			- Vlajky vykonanyh procedur
; * Procedury
;   * Test_Button					- Test klaves
;	* ResetBtn0_Button				- Nulovanie vlajky klavesy
;	* ResetBtn1_Button
;	* ResetBtn2_Button
;	* ResetBtn3_Button
;	* ResetBtn4_Button
;	* ResetBtn5_Button
;	* DoneBtn0_Button				- Vlajka vykonania procedury
;	* DoneBtn1_Button
;	* DoneBtn2_Button
;	* DoneBtn3_Button
;	* DoneBtn4_Button
;	* DoneBtn5_Button
;
; Vypracoval Vladimir Visnovsky

; Port vstupov PortC
; PC5 - nStart		- wStart	- Btn5
; PC4 - nReset		- wReset	- Btn4
; PC3 - nView 1.st	- wView1	- Btn3
; PC2 - nView 2.nd	- wView2	- Btn2
; PC1 - nStop 1.st	- wStop1	- Btn1
; PC0 - nStop 2.nd	- wStop2	- Btn0
.EQU	Btn5	= 0b00100000 	
.EQU	Btn4	= 0b00010000 	
.EQU	Btn3	= 0b00001000 	
.EQU	Btn2	= 0b00000100 	
.EQU	Btn1	= 0b00000010 	
.EQU	Btn0	= 0b00000001
; Operacny register klavesnice 	
.DEF	Btn		= R25
.DEF	BtnDone	= R24	


; Procedury
 ldi	Btn		, 0				; Vynulovanie vlajok klavesnice
 ldi	BtnDone	, 0				; Vynulovanie vlajok vykonanie procedur
 rjmp End_Button
 
; Test klavesnice 
Test_Button:
 ; Nacitanie
 in		R16		, PinC			; Nacitanie klavesy 
 ori	R16		, 0b11000000	; Maska
 com 	R16						; Negacia
 push	R16						; Ulozenie polohy tlacidla
 ; Indikacia stlaceneho tlacidla 
 or 	Btn		, R16			; Zdvihnutie vlajok
 ; Zmazanie indikacie, ak uz bola procedura vykonana
 mov	R16		, BtnDone		; Zmazanie vlajky, ak uz bola procedura 
 com	R16						;  vykonana
 and	Btn		, R16			;
 ; Zmazanie vlajky vykonania procedury
 pop	R16						; Vytiahnutie polohy tlacidla 
 and	BtnDone	, R16			; Vymazanie vlajok vykonania procedur
 ret

; Vynulovania vlajok 
ResetBtn0_Button:
 andi	Btn		, 0b11111110	; Vynulovanie vlajky 
 ret 
ResetBtn1_Button:
 andi	Btn		, 0b11111101	; Vynulovanie vlajky 
 ret 
ResetBtn2_Button:
 andi	Btn		, 0b11111011	; Vynulovanie vlajky 
 ret 
ResetBtn3_Button:
 andi	Btn		, 0b11110111	; Vynulovanie vlajky 
 ret 
ResetBtn4_Button:
 andi	Btn		, 0b11101111	; Vynulovanie vlajky 
 ret 
ResetBtn5_Button:
 andi	Btn		, 0b11011111	; Vynulovanie vlajky 
 ret 

; Vlajky vykonania procedury
DoneBtn0_Button:
 ori	BtnDone	, 0b00000001	; Nastavenie vlajky 
 ret 
DoneBtn1_Button:
 ori	BtnDone	, 0b00000010	; Nastavenie vlajky 
 ret 
DoneBtn2_Button:
 ori	BtnDone	, 0b00000100	; Nastavenie vlajky 
 ret 
DoneBtn3_Button:
 ori	BtnDone	, 0b00001000	; Nastavenie vlajky 
 ret 
DoneBtn4_Button:
 ori	BtnDone	, 0b00010000	; Nastavenie vlajky 
 ret 
DoneBtn5_Button:
 ori	BtnDone	, 0b00100000	; Nastavenie vlajky 
 ret 

   
End_Button: 
 nop
